;; demonstration of creating a counter using the lexical closures
;; supported in racket
#lang racket/base

(define (makecounter init)
  (let ((curval init))                  ;curval will escape 
    (define (inc)                       ;local function
      (set! curval (+ 1 curval))        ;increment curval
      curval)                           ;and return the new value
    inc))                               ;return that function

(define counterF (makecounter 0))
(printf "~v\n" (counterF))
(printf "~v\n" (counterF))
(printf "~v\n" (counterF))

(define counterF2 (makecounter 10))
(printf "~v\n" (counterF2))
(printf "~v\n" (counterF2))
(printf "~v\n" (counterF2))
